// TOPSCCC 9188 demo0
#include<stdio.h>
#include<conio.h>
#include<dos.h>
#include<stdlib.h>
#include<conio.h>
#include "..\lib\9188d.h"

/*void DelayTimeMs(int t)
{
  unsigned int i,j,k,l;
  //loop for delay
  for (i=0; i<t; i++) for (j=0; j<200; j++) k=i*j;
}*/
void WriteToEEP(void){
  int i,j,ret;

  EnableEEP();			/* enable for write */

  printf("\nWrite EEPROM : ");
  for (j=0; j<7; j++){		/* write initial value to all 1K bytes data */
     printf("\nwriting block=%x\n",j);
     for (i=0; i<256; i++) {
	  ret=WriteEEP(j,i,(i+j)&0xff);
	  printf("\raddr=%2X,data=%2X ret=%d",i,(i+j)&0xff,ret);
     }
  }
  printf("\n");

  ProtectEEP();			/* protect data in EEPROM  */

}

void TestNVRAM(void)
{
  unsigned int j=0;
  unsigned char NVRAM[31];

  /* read current NVRAM 0-31 */
  for(j=0;j<31;j++){ NVRAM[j]=ReadNVRAM(j); }
  printf("\nCurrent Values are:\n");
  for(j=0;j<31;j++) printf("%3d ",NVRAM[j]);
  for(j=0;j<31;j++) NVRAM[j]++;  		/* increment by 1 */
  printf("\nAll the values are added by 1");
  for (j=0;j<31; j++) WriteNVRAM(j,NVRAM[j]);  /* write to NVRAM for test */
  printf("\nAfter write Values are:\n");
  for(j=0;j<31;j++) printf("%3d ",ReadNVRAM(j));

}

void TestCom1Com2(void){
	
int i,val,t;
int turn,send_com,read_com,data,no_response;
char c;

no_response=0;
  for(turn=0;turn<4;turn++){

    if(turn==0){ 		//set COM2 send data to COM1
	LedOn();
	send_com=2;
	read_com=1;
	data=0x55;
    }else if(turn==1){          //set COM2 send data to COM1
	send_com=2;
	read_com=1;
	data=0xAA;
    }else if(turn==2){          //set COM1 send data to COM2
	LedOff();
	send_com=1;
	read_com=2;
	data=0x55;
    }else if(turn==3){          //set COM1 send data to COM2
	send_com=1;
	read_com=2;
	data=0xAA;
    }

    Set485DirToTransmit(send_com);
    ToCom(send_com,data);
    WaitTransmitOver(send_com);
    Set485DirToReceive(send_com);

    i=0;
    while(IsCom(read_com)==0) 	//wait for data
    {
	  i++;
	  if (i>30000){
		no_response=1;
		break;
	  }
    }

    //read data if there is any
    if(!no_response){
	val=ReadCom(read_com);
	printf("\nCOM%i send %x --> COM%i receive %x",send_com,data,read_com,val);

    }else{
	printf("\nCOM%i send %x --> COM%i no response",send_com,data,read_com);
	no_response=0;
    }
    
    DelayMs(500);
  }
	
}

void  main()
{ int sec,min,hour;
  int day,mon,year;
  int quit=0,c,i,k,j,t;

  struct date date;		//sturcture of date in DOS.h
  struct time time;            //structire of time in DOS.h

     printf("\nPress 'q' to quit");
     printf("\nPress any key to continue.");
     getch();

 while(!quit)
 {
   printf("\nShowing RTC time for about 10sec.");
   //RTC test for 20 times
   for(i=0;i<20;i++){
     getdate(&date);
     gettime(&time);
     printf("\n%02d-%02d-%4d ",date.da_mon,date.da_day,date.da_year);
     printf("%2d:%02d:%02d",time.ti_hour,time.ti_min,time.ti_sec);
     DelayTimeMs(500);				  /* delay about 0.5 sec */
     if (kbhit())			   /* check user keyboard */
     {
       c=getch();			   /* get user's key-in   */
       if ((c=='q')|| (c=='Q')){ 
       		quit=1; 
       		return;
       }
     }
   }
   
   //-------start NVRAM test
   printf("\nStart NVRAM test.");
   //run it for 4 times
   for(i=0;i<4;i++)
   	TestNVRAM();			  // perform NVRAM test 
   
   //-------start EEPROM test
   printf("\nStart EEPROM test."); 
   WriteToEEP();                 // Write some patterns to EEP 
   //read all 256 bytes
   for (k=0;k<256;k++) {
    i++; i=i&0x01;
    if (i==0) LedOn();	else LedOff();

    printf("\nRead EEPROM : address=%d(%X) data in block 0-7=",k,k);
    for (j=0; j<7; j++) {
	t=ReadEEP(j,k);        // read back EEPROM 
	printf("%02X ",t);
    }
    DelayTimeMs(300);		// delay for 0.3 sec

    while (kbhit() != 0) {
       c=getch();
       if ((c=='q')|| (c=='Q')) return;
       printf("(%c)",c);
    }
   }
   
   //---------Start COM1 COM2 RS485 test
   printf("\nStart COM1/COM2 RS485 test.");
   InstallCom(1,57600L,8,0,1);	/* COM1, RS485 */
   InstallCom(2,57600L,8,0,1);	/* COM2, RS485 */
   TimerOpen();			/* for DelayMs() */
   //test for 4 times
   for(i=0;i<4;i++){
     TestCom1Com2();
     if (kbhit())		
     {
       c=getch();		
       if ((c=='q') || (c=='Q'))
	  {
	  RestoreCom(1);
	  RestoreCom(2);
          TimerClose();
	  return;
	  }
     }
   }
   RestoreCom(1);
   RestoreCom(2);
   TimerClose();
 
 
 
 }
}

