#include<stdio.h>
#include<stdlib.h>
#include<conio.h>
#include<string.h>
#include<time.h>
#include "..\lib\9188d.h"

/*
 Use 9188 COM2 link to 9053/52(16/8 D/I) x 2 and 7041() x 2.
 address 01 : 9053-1, connect to COM2(RS485) of 7188
	      9600,N,8,1
 address 02 : 9053-2, connect to COM2(RS485) of 7188
	      9600,N,8,1
 address 03 : 9041-1, connect to COM2(RS485) of 7188
	      9600,N,8,1
 address 04 : 9041-2, connect to COM2(RS485) of 7188
	      9600,N,8,1
 9188 COM4 link to PC COM port

 5digitled  : digit 1 will show channel no.
	      digit 2-5 will show the input value
*/


unsigned CheckTime;

char h_to_a[16] ={
 '0','1','2','3','4','5','6','7',
 '8','9','A','B','C','D','E','F'
};

char *Binary[16]=
{
  "0000",
  "0001",
  "0010",
  "0011",
  "0100",
  "0101",
  "0110",
  "0111",
  "1000",
  "1001",
  "1010",
  "1011",
  "1100",
  "1101",
  "1110",
  "1111",
};

int ascii_to_hex(char c){
 if(c<='9')
	return(c-'0');
 else
	return(c-'A'+10);
}
/*-----------------------------------------------------*/
/* This function sends commands and receive result from 9000 module */
/* It also shows the DIO status on 5-digit LED */
/* It also shows the result to the PC console */
int read_9000(unsigned char *cmd)
{  unsigned char str[20];
   int val,data;
   static unsigned long count=0;

   count++;
   SendCmdTo9000(2,cmd, 0);
   printf("\n[%lu]Send=%s, Receive=",count,cmd);
   val=ReceiveResponseFrom9000(2,str, 60000L, 0);
   if (val==NoError) {
      printf("%s ",str);
      /* show the I/O value */
      data=ascii_to_hex(str[1]);
      Show5DigitLed(2,data);
      printf("[%s",Binary[data]);
      data=ascii_to_hex(str[2]);
      Show5DigitLed(3,data);
      printf(" %s",Binary[data]);
      data=ascii_to_hex(str[3]);
      Show5DigitLed(4,data);
      printf(" %s",Binary[data]);
      data=ascii_to_hex(str[4]);
      Show5DigitLed(5,data);
      printf(" %s]",Binary[data]);
   }
   else printf("Errorno=%d(%s)",val,val==TimeOut?"TimeOut":"");
   return val;
}

/*---------------------------------------------------*/
/* Get the module name */
int GetModuleName(int addr,char *name)
{ char cmd[10];
  int val,i;

  cmd[0]='$';
  cmd[1]=h_to_a[(addr>>4)&0xf];
  cmd[2]=h_to_a[addr&0xf];
  cmd[3]='M';
  cmd[4]=0;
  SendCmdTo9000(2,cmd, 0);
  val=ReceiveResponseFrom9000(2,cmd, 60000L, 0);
  if(val==NoError) {
     if(cmd[0]=='!'){
	for(i=0;i<4;i++){
	   name[i]=cmd[3+i];
	}
	name[i]=0;
	return NoError;
     }
     else return PortError;
  }
  return val;
}

/* ------------------------------------------------------------------- */
char OutCmd[10]="@01";
int Name[4];
void  main()
{ int i,k;
  unsigned char c,cmd[80];
  int ledmode=1;
  int quit=0;
  int channel=-1;
  clock_t start,end,start2;

  InstallCom(2,9600L,8,0,1);	/* COM2, RS-485, half-duplex mode, INT	     */
				/*	 --> need to control 485 direction   */
				/*	 --> initial 485 direction = Receive */

  /* COM4, RS-232, connect to PC's COM port for download   */
  Init5DigitLed();		/* initial & blank the 5-digit LED  */
  LedOn();			/* red-LED on			    */
  start=clock();
  //get the module name in the network
  for(i=1;i<=4;i++){
     if(GetModuleName(i,cmd)==NoError){
	Name[i]=atoi(cmd);
	Show5DigitLed(1,i);
	Show5DigitLed(2,cmd[0]-'0');
	Show5DigitLed(3,cmd[1]-'0');
	Show5DigitLed(4,cmd[2]-'0');
	Show5DigitLed(5,cmd[3]-'0');
     }
     else {
	Name[i]=0;
	Show5DigitLed(1,i);
	Show5DigitLed(2,17);
	Show5DigitLed(3,17);
	Show5DigitLed(4,17);
	Show5DigitLed(5,17);
     }
  }

  for(i=1;i<=4;i++){
      if(Name[i]==9052 || Name[i]==9053 || Name[i]==9041 ||
	 Name[i]==7052 || Name[i]==7053 || Name[i]==7041){

	 channel=i;
	 Show5DigitLed(1,i);
	 OutCmd[2]=i+'0';
	 break;
      }
  }

  printf("\n'1': show channel 1\n'2': show channel 2"
	 "\n'3': show channel 3\n'4': show channel 4"
	 "\n'q'  : quit"
	 "\npress any key to start.");

  if(Name[channel]==9052 || Name[channel]==9053 || Name[channel]==9041 ||
     Name[channel]==7052 || Name[channel]==7053 || Name[channel]==7041){
     while(!quit) {
       end=clock();
       //blink LED
       if((end-start)/CLK_TCK >= 0.5){
	  ledmode=!ledmode;  if (ledmode) LedOn(); else LedOff();
	  start=clock();
       }
       if (kbhit()) {		/* is user press PC's keyboard from COM4   */
	  c=getch();		/* if this key is Q or Q --> exit this program */
	  switch(c){
	   case 'q': case 'Q': quit=1; break;
	   case '1':
	   case '2':
	   case '3':
	   case '4':
		if(Name[c-'0']==9052 || Name[c-'0']==9053 || Name[c-'0']==9041 ||
		   Name[c-'0']==7052 || Name[c-'0']==7053 || Name[c-'0']==7041){
		   channel=c-'0';
		   Show5DigitLed(1,channel);
		   OutCmd[2]=c;
		}
		break;
	  }
       }
       else {
	   read_9000(OutCmd);
       }
     }
  }
  else printf("\nCannot find 9053 or 9041 on address 0-3");
  RestoreCom(2);
  return;
}

/* ------------------------------------------------------------------- */

